from ctypes import *
import sys
from Phidget22.PhidgetLibrary import PhidgetLibrary
from Phidget22.VINT.PhidgetVINT import PhidgetVINT, PhidgetVINTID, PhidgetVINTClass
from Phidget22.PhidgetException import PhidgetErrorCodes, PhidgetException
from Phidget22.VINT.ManagerVINT import ManagerVINT

try:
    manager = ManagerVINT()
except RuntimeError as e:
    print("Runtime Exception %s" % e.details)
    print("Exiting...")
    exit(1)

def ManagerAttached(e):
    try:
        print ("Attached: FIX deviceName on port: %d on channel %d" % (e.device.getHubPort(),e.device.getChannel()))
    except PhidgetException as e:
        print("Phidget Exception %i: %s" % (e.code, e.details))
        print("Exiting....")
        exit(1)   
    
def ManagerDetached(e):
    detached = e.device
    try:
        print("Detach event on Port %d Channel %d" % (detached.getHubPort(), detached.getChannel()))
    except PhidgetException as e:
        print("Phidget Exception %i: %s" % (e.code, e.details))
        print("Exiting....")
        exit(1)   
def ErrorEvent(e):
    print("Error %i : %s" % (e.eCode, e.description))

try:
    manager.setOnAttachHandler(ManagerAttached)
    manager.setOnDetachHandler(ManagerDetached)
    manager.setOnErrorHandler(ErrorEvent)
    print("Opening Manager...")
    manager.openManager()
except PhidgetException as e:
    print("Phidget Exception %i: %s" % (e.code, e.details))
    print("Exiting....")
    exit(1) 
    
print("Press Enter to quit...")
readin = sys.stdin.read(1)
try:
    manager.closeManager()
except PhidgetException as e:
    print("Phidget Exception %i: %s" % (e.code, e.details))
    print("Exiting....")
    exit(1) 
print("Finished")
exit(0)
                     
